//
// This code was created by Jeff Molofee '99
//
// If you've found this code useful, please let me know.
//
// Visit me at www.demonews.com/hosted/nehe
//
/**************************************************************/
// This code was ported to MacOS by Tony Parker.
//  I'd also appreciate it if you could drop me a line if you found
//  this code useful. 
// 
//  Tony Parker - asp@usc.edu
// 
// Have a nice day.

/*
#include <Types.h>
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Events.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <Sound.h>
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "math.h"

#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#include <stdlib.h>
//#include "TGALoader.h"
//#include "tk.h"					// We're using the TK lib to load textures (NEW)

#include "LoadTGA.h"

// Constants -----------------------------------------------------------------

#define kWindowWidth	512
#define kWindowHeight	256

// Function Prototypes -------------------------------------------------------

GLvoid InitGL(GLvoid);
GLvoid DrawGLScene(GLvoid);
GLvoid ReSizeGLScene(int Width, int Height);
GLvoid keyboard(unsigned char key, int x, int y);
GLvoid Idle(GLvoid);
GLvoid LoadGLTextures(GLvoid);
TGAImageRec*	LoadTGA( char *filename );

// Global Variables ----------------------------------------------------------

unsigned long 	texture[1];		// Texture Storage ( NEW )

GLfloat			xrot;			// X Rotation ( NEW )
GLfloat			yrot;			// Y Rotation ( NEW )
GLfloat			zrot;			// Z Rotation ( NEW )





// Main ----------------------------------------------------------------------

int main(int argc, char** argv)
{
	
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(kWindowWidth, kWindowHeight); 
    glutInitWindowPosition (100, 100);
    glutCreateWindow (argv[0]);
	
	InitGL();
 
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(DrawGLScene); 
    glutReshapeFunc(ReSizeGLScene);
    glutIdleFunc(Idle);
	
	xrot = 0;
	yrot = 0;		
	zrot = 0;
	
    glutMainLoop();
  
    return 0;
}

// InitGL --------------------------------------------------------------------

GLvoid InitGL(GLvoid)
{
	
	LoadGLTextures();							// Load The Texture(s) ( NEW )
	glEnable(GL_TEXTURE_2D);					// Enable Texture Mapping ( NEW )
	
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
	glClearDepth(1.0);							// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);						// The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);					// Enables Depth Testing 
	glShadeModel(GL_SMOOTH);					// Enables Smooth Color Shading

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();							// Reset The Projection Matrix

	gluPerspective(45.0f, (GLfloat) kWindowWidth / (GLfloat) kWindowHeight, 0.1f, 100.0f);	
												// Calculate The Aspect Ratio Of The Window

	glMatrixMode(GL_MODELVIEW);

}

// Keyboard ----------------------------------------------------------------------

GLvoid keyboard(unsigned char key, int x, int y)
{
	switch(key)
	{
		case 27: exit(0); break;
                case 'q': exit(0); break;
		default: printf("x: %d  y: %d\n", x, y);
	}
}

// Idle ----------------------------------------------------------------------

GLvoid Idle(GLvoid)
{
	xrot += 0.3f;			// X Axis Rotation
	yrot += 0.2f;			// Y Axis Rotation
	zrot += 0.4f;			// Z Axis Rotation
	
	glutPostRedisplay();
}

// DrawGLScene ---------------------------------------------------------------

GLvoid DrawGLScene(GLvoid)
{    
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0.0f,0.0f,-5.0f);
	
	glRotatef(xrot,1.0f,0.0f,0.0f);				// Rotate On The X Axis
	glRotatef(yrot,0.0f,1.0f,0.0f);				// Rotate On The Y Axis
	glRotatef(zrot,0.0f,0.0f,1.0f);				// Rotate On The Z Axis
	
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
		// Back Face
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
		// Top Face
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		// Bottom Face
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		// Right face
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		// Left Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
	glEnd();
	
	
	
    glutSwapBuffers();
    glFlush();
}

// ReSizeGLScene ------------------------------------------------------------

GLvoid ReSizeGLScene(int Width, int Height)
{
    glViewport (0, 0, (GLsizei) Width, (GLsizei) Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(45.0, (GLfloat) Width / (GLfloat) Height, 0.1, 100.0);
   
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

// LoadGLTextures ----------------------------------------------------------

GLvoid LoadGLTextures(GLvoid)
{

	/*TK_RGBImageRec 			*texture1; */
	TGAImageRec		*texture1;	
	char pix_name[32] = "crate.tga";
	GLuint			type;
	
	/*printf("Enter in name of image: ");
        scanf("%s", pix_name);
        printf("Picture name: %s\n", pix_name);
	*/
	/*texture1 = tkRGBImageLoad("NeHe.sgi");
	 texture1 = tkRGBImageLoad("tile3.bmp"); */


	texture1 = LoadTGA(pix_name); /* load the image */
	printf("Width: %d  Height: %d\n", texture1->sizeX, texture1->sizeY);

	glGenTextures(1, &texture[0]);
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			
	if ( texture1->bpp == 24 )
		type = GL_RGB;
	else
		type = GL_RGBA;
			
	glTexImage2D(GL_TEXTURE_2D, 0, type, texture1->sizeX, texture1->sizeY, 0, type, GL_UNSIGNED_BYTE, texture1->data);
			

/*
	glPixelStorei(GL_UNPACK_ALIGNMENT,   1   );
	
	glTexImage2D(GL_TEXTURE_2D, 		//target 
			0, 							//level
			GL_RGB, 					//internalFormat
			texture1->sizeX, 			//w
			texture1->sizeY,			//h
			0, 							//border
			GL_RGB, GL_UNSIGNED_BYTE, 	//format,type
			texture1->data);			//data
				
	// Create Texture
	glGenTextures(1, &texture[0]);
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 
				 texture1->sizeX, texture1->sizeY, 0, 
				 GL_RGB, GL_UNSIGNED_BYTE, texture1->data);

*/
}



